#include "Jonkers_Schorr_Waite(bitheap).h"
#include "BitHeap.h"

static ptr D;

static ptr unthread(ptr P)
  { ptr N = P->P;
    typ T = P->T;
    if (is_chunk(P))
      *P = (cel){ D, p, u };
    else
      *P = (cel){ D, p, m };
    if (T == h)
      return N;
    return unthread(N); }

static void thunk(void * Address)
  { ptr A, S, S_;
    unsigned L1;
    S = Address;
    for (A = S; ; )                 // A <- S
      { S_ = S->P;                  // S^
        if (S->T == h)              // Sw = h
          { L1 = size(S_) + 1;      // size(S^) + 1
            *A = *S;                // *A <- *S
            if (is_chunk(S))        // chunk?(S)
              *S = (cel){ D, p, u };// *S <- [D, p, u]
            else                    // pair?(S)
              *S = (cel){ D, p, m };// *S <- [D, p, m]
            D += L1;                // D <- D + size(S^) + 1
            break; }                // stop
        else                        // Sw = p
          { if (is_chunk(S))        // chunk?(S)
              *S = (cel){ D, p, u };// *S <- [D, p, u]
            else                    // pair?(S)
              *S = (cel){ D, p, m };// *S <- [D, p, m]
            S = S_; }}}             // S <- S^

static void thunk0(void * Address)
  { ptr S = Address;
    ptr Q = unthread(S);
    *S = (cel){ Q, h, m };
    D += size(Q) + 1; }

void Jonkers_Schorr_Waite_bitheap_unthread(void)
  { D = Memory + 1;
    BitHeap_foreach(thunk); }
